\chapter{The internship}
In order to become a computer engineer, I had the opportunity to carry out a 3-month-internship.
 The purpose of this internship was to discover the enterprise world and build a professional experience.

	\section{the company}
For this internship, I chose to join the institute of research AIST in Japan.
 More precisely, The Research Institute for Secure Systems of the kansai branch of AIST, in Amagasaki.

		\subsection[The National Institute of AIST]{The National Institute of Advanced Industrial Science and Technology}
The National Institute of Advanced Industrial Science and Technology (AIST),
 led by President Chubachi, is a public research institution funded by the Japanese government to a large extent.
 The present AIST is a rather new research organization established in 2001.
 However, AIST and its predecessor organizations have been contributing to society through continuous advancement in technologies
 and support to Japanese industries since 1882. 

Headquarters of AIST are located in Tsukuba and Tokyo.
 AIST has over 40 autonomous research units in various innovative research fields,
 and the units are located at ten research bases and several sites (smaller than research bases) of AIST all over Japan.
 About 2300 researchers (about 2000 with tenure: about 80 from abroad) and a few thousands of visiting scientists,
 post-doctoral fellows, and students from home and abroad are working at AIST.
 About 650 permanent administrative personnel and many temporary staff support research works of AIST.

AIST was ranked 7th in Top 20 Japanese research institutions for all field announced on April 15, 2014, by Thomson Reuters.
 AIST was also ranked high in category rankings: 5th in chemistry, 5th in materials science, and 7th in biology and biochemistry.
 The rankings are based on the number of highly cited academic papers published from January 2003 to October 2013.

The organisation chart of AIST can be seen on the first page of the appendix.

		\subsection{AIST Amagasaki, RISEC}
The Research Institute for Secure Systems(RISEC) is established on April 1,
 2012 by reorganizing several research groups within AIST related to system security and reliability.
 This institute is situated inside AIST Amagasaki's premises.

			\subsubsection{RISEC's outline}
In parallel to the outstanding development of IT and spread of Internet connectivity,
 the IT equipment and information assets are faced to expanding threats.
 To develop technologies to protect these assets is RISEC's mission.

In addition to development of new technologies to raise system security level,
 actions are needed to make the technologies be used in the real industries and society.
 For such deployments, security, safety and dependability of IT must be recognized as new values to industries,
 which produce economical value to make security business cycle sustain spontaneously.
 Such help to industries or promotion of innovations is also RISEC's mission.

RISEC tackles with these security problems in scientific and engineering manners,
 paying attentions to human factor and legal institutions at the same time, thus forming a systematic solution.
 Safety is now a global problem, and scientist group like RISEC is not the only stake holder.
 RISEC try to collaborate and to make liaisons with the government, private companies,
 NPO, research institutes overseas, etc.

			\subsubsection{Research projects}
All the following research subjects are important for RISEC:
 innovative use of cryptography in Internet and cloud services,
 control system security to protect important social infrastructures such as electricity,
 railways, water, etc. from cyber attacks, counter measures to side-channel attacks to electronics including IC cards,
 system design methodology to prevent errors injected at design stages and operational stages,
 and counter measures to arising threats which might be introduced by future quantum computing.

Currently the research projects pursued by RISEC are the following:
\begin{itemize}
\item Secure Services
	\begin{itemize}
	\item Secure authentication methods on the internet
	\item Countermeasures for human errors
	\item Error correcting codes - mathematics for information reliability
	\end{itemize}
\item Control System and Hardware Security
	\begin{itemize}
	\item Securing control systems
	\item Hardware security evaluation
	\end{itemize}
\item Development of Secure Software
	\begin{itemize}
	\item Designing secure software
	\item Implementing secure software
	\item Ensuring/verifying software safety
	\item Enforcing secure software execution
	\end{itemize}
\item Innovative Security Technologies for the Next Generation
	\begin{itemize}
	\item More reliable security proofs for cryptographic technologies
	\item Design and analysis of highly functional cryptographic primitives
	\item Privacy-preserving database search
	\end{itemize}
\end{itemize}

	\section{The subject of the internship}
This is in the context of the project "designing secure software" that this internship must be considered,
 and more precisely, in the research project "Modbat", a model base tester.
 Under the guidance of the main contributor to this project in AIST, Dr. Cyrille ARTHO,
 the subject of this internship concerned the use of this model base tester with ZooKeeper.

		\subsection{Modbat}
Modbat is a model-based testing tool that is based on annotated (extended) finite-state machines.
 Modbat is specialized in testing the application programming interface (API) of software.
 The model used by Modbat is compatible with Java byte-code.
 The user defines and compiles a model, which is then explored by Modbat and executed against the system under test.
 Failed test runs are reported as an error trace.

The strength of this model is that it uses an easy-to-learn modelling language with graphical view of model,
 it generates efficient test generation and execution, and it offers off-line test case generation and other advanced features.

Modbat is based on Scala and compatible with any Java-based software.
 The model has the structure of a non-deterministic finite-state machine.
 From all possible transitions, one is chosen to be tested;
 annotations of the transition specify which code to execute.

\begin{figure}[h]
\centering
\includegraphics[scale=0.75]{image/fsm.pdf}
\caption{Extended finite-state machine}
\end{figure}

		\subsection{Internship planning}
Extending over a long period, me and my supervisor established a planning for this 3 months of work.
 The first week of the internship has been dedicated into learning the programming language Scala,
 and a first use of Modbat with the Java libraries' lists.
 For a period of 1 month, still in the purpose to get used with Modbat,
 I have worked on the modelling of a simple network.
 At last, for the rest of the internship, the main goal of this internship is to use Modbat in order to test ZooKeeper.

		\subsection{Goal of this work}
The purpose of this work is to help the development of Modbat.
 As a new user of this software, we can see if it is easy to understand and learn using Modbat,
 and how long time does it take to create a simple model.
 Moreover this work can help this project in many other aspects:
\begin{itemize}
\item Explain better some complex aspect of the software for a new user
\item have an external point of view
\item improve the interface
\item have new ideas in order to use Modbat more easily
\item add some new features
\item test the capacity of Modbat to handle complex model
\end{itemize}